# ../addons/eventscripts/_libs/python/restrictlib.py
# Restrict Library by MiBShidobu
'''
from restrictlib import getPlayer

def player_spawn(ev):
    playerTeam = ev['es_userteam']
    if playerTeam == '3':
        getPlayer(ev['userid']).add('usp')

    elif playerTeam == '2':
        getPlayer(ev['userid']).add('glock')
'''
from es import gethandlefromindex, getuserid, addons, exists, entitygetvalue
from weaponlib import getWeapon
from spe import detourFunction, HookType, HookAction, getIndexOfEntity, dropWeapon, ownsWeapon

__all__ = ['getPlayer']

def es_map_start(ev):
    global playerData
    playerData = {}

def player_disconnect(ev):
    playerUserid = int(ev['userid'])
    if playerUserid in playerData:
        del playerData[playerUserid]

def player_death(ev):
    getPlayer(ev['userid']).clear()

class weaponSet(set):
    def __init__(self, playerUserid):
        self.playerUserid = playerUserid
    
    def add(self, keyItem):
        keyItem = getWeapon(keyItem)
        if keyItem:
            if ownsWeapon(self.playerUserid, keyItem.name):
                dropWeapon(self.playerUserid, keyItem.name)

            set.add(self, keyItem.name)

    def discard(self, keyItem):
        keyItem = getWeapon(keyItem)
        if keyItem:
            set.discard(self, keyItem.name)

def getPlayer(playerUserid):
    playerUserid = int(playerUserid)
    if not exists('userid', playerUserid):
        raise KeyError, playerUserid

    if not playerUserid in playerData:
        playerData[playerUserid] = weaponSet(playerUserid)

    return playerData[playerUserid]

def playerCommand(playerUserid, commandArgs):
    if commandArgs[0].lower() == 'buy' and len(commandArgs) == 2:
        weaponObject = getWeapon(commandArgs[1].lower())
        if weaponObject:
            if weaponObject.name in getPlayer(playerUserid):
                return False

    return True

def playerPickup(hookArgs):
    playerIndex = getIndexOfEntity(hookArgs[1])
    if playerIndex:
        playerUserid = getuserid(gethandlefromindex(playerIndex))
        if entitygetvalue(getIndexOfEntity(hookArgs[0]), 'classname') in getPlayer(playerUserid):
            return (HookAction.Override, 0)

    return (HookAction.Continue, 0)

playerData = {}

moduleSelf = __import__(__name__)
addons.registerForEvent(moduleSelf, 'player_death', player_death)
addons.registerForEvent(moduleSelf, 'es_map_start', es_map_start)
addons.registerForEvent(moduleSelf, 'player_disconnect', player_disconnect)
addons.registerClientCommandFilter(playerCommand)

detourFunction('BumpWeapon', HookType.Pre, playerPickup)
 